/**
 * 1. Daten holen 2. Daten parsen 3. View aufbauen 4. View Funktionalität 5. los
 */

;
(function($) {

	var kbb;
	kbb = this.kbb = {};
	kbb.widgetName = "Checker";

	kbb.editModeSize = 'L';
	kbb.infoModeSize = 'L';
	
	kbb.locale = "en";
	kbb.type = "large";
	kbb.dataPath = "data/";
	
	kbb.items = [];
	
	kbb.labelText = NB.localize("Drag or write text here");

	kbb.widgetWidth = 320;
	kbb.widgetHeight = 120;
	
	
	kbb.smartTextProperties = {x:100, y:200 };

	kbb.html = "";

	kbb.editModeFormElements = [ {
		type : 'list',
		label : 'Answers',
		name : 'answers',
		initial : ''
	}, {		
		type : 'checkbox',
		label : 'Case sensitive',
		name : 'caseSensitive',
		initial : 1
	}, {
		type : 'checkbox',
		label : 'Contains',
		name : 'contains',
		initial : 1
	
	}, {
		type : 'radiogroup',
		label : 'Action if correct',
		name : 'actionIfCorrect',
		items: [{ value: 'gotoNextPage', title: 'Go to next page'},
		        //{ value: 'playSound', title: 'Play sound'},
		        { value: 'insertedText', title: 'Insert text'}],
		initial : 'insertedText'
	}, {
		type : 'input',
		label : 'Text for correct answer',
		name : 'customInput',
		initial : ''
	}, {
		
		type : 'okCancel',
		okName : 'saveForm',
		cancelName : 'cancelForm'
	}

	];

	
	
	kbb.cancelForm = function() {
		
		EM.hideForm();
		$('#status').removeClass('wrong').hide();
	};
	
	
	kbb.editMode = function() {
		
		KBBUTIL.editModeSize = kbb.editModeSize;
		KBBUTIL.addEditMode(kbb.editModeFormElements);
		KBBUTIL.infoModeSize = kbb.infoModeSize;
		KBBUTIL.addInfoMode();
	};
	
	
	kbb.initFromPersistance = function() {
	
		KBBUTIL.log("kbb.initFromPersistance");
		$('#status').removeClass('wrong').hide();
		$('#labelWord').html(kbb.labelText);
		
		var widget = KBBUTIL.getWidgetObject();
		widget.width = kbb.widgetWidth;
		widget.height = kbb.widgetHeight;
		$('body').css('width', kbb.widgetWidth);
		$('body').css('height', kbb.widgetHeight);
	};	
	
	
	
	kbb.addEvents = function() {

		KBBUTIL.log("kbb.addEvents");

		$('.stageWrapper').click(function() {

		});

		$('#status').click(function() {

			$('#labelWord').html(kbb.labelText);
			$(this).hide();
		});
		
		
		NB.helpers.handwritable( $("#widgetContainer"), function(text, obj) {
			
			$('#labelWord').html(text);
			kbb.compare( text );
		}, { timeToRecognize: 2 });
		//, { activeBackgroundColor: "#ddd", timeToRecognize: 2 }
		
		NB.addObserver("dndDropEvent", function(evt) {

			for ( var guid in evt.eventData) {

				var chk = NB.getObject(guid);

				if (NB.getHostObject().contains(chk.x, chk.y)) {

				
					if(EM.mode === false) {
						
						var myVal = chk.getCustomProperty('myVal', null);
						
						if(myVal !== undefined && myVal !== null) {
							
							KBBUTIL.log("myVal " + myVal);
							kbb.compare(myVal);
						}
						else if(chk.text !== undefined || chk.getText() !== undefined ) {
							
							var txt = chk.getText();
							txt = (txt == undefined) ? chk.getText() : txt;
							//KBBUTIL.log("chk.getText() " + txt);

							kbb.compare( txt );
							$('#labelWord').html(txt);
							chk.deleteObject();
						}
					}
				}
			}
		});
		//KBBUTIL.log("actionifcorrect: "+KBBUTIL.load("actionIfCorrect"));
		
		if(KBBUTIL.load("actionIfCorrect") == 'insertedText' || KBBUTIL.load("actionIfCorrect") == "not-found")
			$('.customInput').show();
		
		//NEXT AND LAST STEP
		KBBUTIL.moveToBack();
	};
	
	
	kbb.compare = function(dropped) {
		
		var savedAnswers = KBBUTIL.load("answers");
		var answers = savedAnswers.split(",");
		var contains = KBBUTIL.load("contains");
		var caseSensitive = KBBUTIL.load('caseSensitive');

KBBUTIL.log(">>>>> "+savedAnswers +" "+ contains + " " +caseSensitive);		
		
		var droppedSmall = dropped.toLowerCase();

		
		/*
		 * if answer is correct or
		 * not case-sensitive and answer is correct or
		 * contains allowed and answer contains saved-answer
		 * */
		for(var i=0; i<answers.length; i++) {
			
			var saved = answers[i];
			var savedSmall = saved.toLowerCase();

			if(
				saved == dropped ||
				(caseSensitive == '0' && savedSmall == droppedSmall ) ||
			  	(contains == '1' && caseSensitive == '0' && (droppedSmall.indexOf(savedSmall) != -1 || savedSmall.indexOf(droppedSmall) != -1) ) ||				
			  	(contains == '1'  && caseSensitive == '1' && (dropped.indexOf(saved) != -1 || saved.indexOf(dropped) != -1) )				
			) {
				
				kbb.markAsCorrect();
				return;
			}
		}
		
		kbb.markAsWrong();
	};

	
	kbb.markAsWrong = function() {
		
		//var showSuccess = KBBUTIL.load("actionIfCorrect");
			$('#status').addClass('wrong').show();
	};
	
	
	kbb.markAsCorrect = function() {
		
		var showSuccess = KBBUTIL.load("actionIfCorrect");
		var successText = KBBUTIL.load("customInput");
		showSuccess = (showSuccess == "insertedText") 
			? showSuccess : "gotoNextPage";
		
		$('#status').removeClass('wrong').show();

		if(showSuccess == "insertedText") {
			
			var prototype = KBBUTIL.createTextObject(successText, kbb.smartTextProperties);
			NB.addObject(prototype);
		}
		else if(showSuccess == "gotoNextPage") {
			
			NB.document.viewNextPage();
		}
	};
	

	kbb.getViewStage = function() {

		KBBUTIL.log("kbb.getViewStage");


		var html =  
			'<div id="display">' + 
			'<article class="stageWrapper">' + 
			'<p id="labelWord">Drag text here</p>' +
			'<div id="status" style="display:none"></div>' +
			'</article>' +
			'</div>';


		return html;
	};


	kbb.createView = function() {

		KBBUTIL.log("kbb.createView");

		kbb.html = '<section class="container">' + 
				kbb.getViewStage() +
				'</section>';
		kbb.element.html(kbb.html).removeClass("preloader");

		kbb.initFromPersistance();
		kbb.editMode();		
		
		$('#widget').addClass(kbb.widgetName);
		
		// NEXT STEP
		kbb.addEvents();
	};

	$.fn.startUP = function(locale) {

		kbb.locale = locale;
		kbb.element = $(this);


		// NEXT STEP
		kbb.createView();
		NB.localization.translateHtmlElements();
	};


})(jQuery);


$('#widgetContainer').startUP(locale);